<template>
	<v-card id="eventCard">
		<v-btn icon>
			<v-icon @click="$emit('closePopup')">mdi-close</v-icon>
		</v-btn>
		<h1 class="text-center mb-5">פרטי האירוע</h1>
		<h4 class="mr-5 mb-3" v-for="(value, key) in eventData" :key="key">
			{{ getDisplayName(key) }} : {{ value }}
		</h4>
	</v-card>
</template>

<script>
import api from '../api';

export default {
	name: 'eventPopup',
	created() {
		this.getEventData();
	},
	data() {
		return {
			properties: [
				{ prop_name: 'stabber_id', display_name: 'ת.ז. דוקר' },
				{ prop_name: 'weapon_type', display_name: 'סוג נשק' },
				{ prop_name: 'casualties_num', display_name: 'מספר נפגעים' },
				{ prop_name: 'kidnapper_id', display_name: 'ת.ז. חוטף' },
				{ prop_name: 'kidnapped_id', display_name: 'ת.ז. נחטף' },
				{ prop_name: 'last_place_known', display_name: 'נצפה לאחרונה' },
				{ prop_name: 'shooter_id', display_name: 'ת.ז. יורה' },
				{ prop_name: 'hitter_id', display_name: 'ת.ז. נפגע' },
				{ prop_name: 'hit_id', display_name: 'ת.ז. פגוע' },
			],
			eventData: {},
		};
	},
	props: {
		eventId: { type: String, required: true },
		eventType: { type: String, required: true },
	},
	methods: {
		getEventData() {
			api.reports.reportById(this.eventType, this.eventId).then(res => {
				const asArray = Object.entries(res.data);
				const filteredArray = asArray.filter(
					obj =>
						obj[0] != 'report' &&
						obj[0] != 'accidentId' &&
						obj[0] != 'stabbingReport' &&
						obj[0] != 'shootingReport' &&
						obj[0] != 'kidnapId',
				);
				this.eventData = Object.fromEntries(filteredArray);
			});
		},
		getDisplayName(key) {
			return this.properties.find(prop => prop.prop_name == key).display_name;
		},
		getValue(key) {
			return this.eventData[key];
		},
	},
};
</script>

<style scoped>
h1 {
	color: #38919b;
}

#eventCard {
	background-color: #dfeeea;
	opacity: 0.95;
	height: 25vh;
}

h4 {
	color: rgba(0, 0, 0, 0.623);
}
</style>
